import {environment} from '../../../environments/environment';
import {NzMessageService, NzModalService} from 'ng-zorro-antd';
import {Component, OnInit, Injector} from '@angular/core';
import {HttpClient} from '@angular/common/http';
import {ActivatedRoute} from '@angular/router';
import * as echarts from 'echarts';
import * as $ from 'jquery';
@Component({
  selector: 'app-report',
  templateUrl: './report.component.html',
  styles: []
})
export class ReportComponent implements OnInit {
  [x: string]: any;

  constructor(
    public injector: Injector,
    public http: HttpClient,
    public activeRoute: ActivatedRoute,
    public msgSrv: NzMessageService
  ) {
    for (let index = 0; index < 19; index++) {
      this.sensorArr.push(index);
    }
  }

  public echartOption = {
    title: {
      text: '',
      // subtext: '12月份',
      left: 'center'
    },
    tooltip: {
      trigger: 'axis'
    },
    legend: {
      data: [],
      left: 'left'
    },
    toolbox: {
      show: false,
      feature: {
        dataZoom: {
          yAxisIndex: 'none'
        },
        dataView: {readOnly: false},
        magicType: {type: ['line', 'bar']},
        restore: {},
        saveAsImage: {}
      }
    },
    xAxis: {
      type: 'category',
      // boundaryGap: false,
      data: [],
      name: ''
    },
    yAxis: {
      type: 'value',
      name: ''

    },
    series: [
      {
        smooth: true,
        type: 'line',
        data: [],
        name: ''
      },
      {
        smooth: true,
        type: 'line',
        data: [],
        name: '',
        itemStyle: {
          normal: {
            barBorderRadius: [10, 10, 10, 10]
          }
        }
      }
    ]
  };

  sensorArr: any = [];
  arr = new Array();

  ngOnInit() {
    this.activeRoute.queryParams.subscribe(params => {
      const query = params;
      console.info(query.label);
      query.items = JSON.parse(query.items);
      this.http.post(environment.SERVER_BASH_URL + 'report/compare', query).subscribe((res: any) => {
        if (res.code === 0) {
          this.msgSrv.error(res.message);
        } else {
          const option = this.echartOption;
          const data = res.data;
          if (data['time']) {
            option.xAxis.data = data['time'];
            option.series[0].data = [];
            option.legend.data[0] = '';
            option.series[0].name = '';
            option.series[1].data = [];
            option.legend.data[1] = '';
            option.series[1].name = '';
            option.xAxis.name = query.xAxisName;
            if (data.dataA) {
              const legendNamea = (query.deviceaName ? query.deviceaName : query.monitorPointaName) + query.time + query.label;
              option.legend.data[0] = legendNamea;
              option.series[0].name = legendNamea;
              let index = 0;
              for (const key in data.dataA[0]) {
                this.arr.push(index);
                let split = key.split('-');
                option.title.text = split[1] + query.label + '历走势图';
                option.series[0].data = data.dataA[0][key];
                option.yAxis.name = split[2];
                const myChart = echarts.init(document.getElementById('mydiv' + index));
                myChart.setOption(option, true);
                window.onresize = myChart.resize;
                index++;
              }
              this.sensorArr.forEach(i => {
                if (this.arr.indexOf(i) == -1) {
                  $('#mydiv' + i).remove();
                }
              });
            }
            if (data.dataB) {
              const legendNameb = (query.devicebName ? query.devicebName : params.monitorPointbName) + query.timeb + query.label;
              option.series[1].data = data['dataB'];
              option.legend.data[1] = legendNameb;
              option.series[1].name = legendNameb;
            }
          }
        }
      });
    });
  }

}
